function [] = PlotData(Data,L,varargin)
if(isvector(L))
    L = L(:);
    vUniqueLabels = unique(L); 
    [Y,CrispLabel]= ismember(L,vUniqueLabels);
    NrLabels      = numel(vUniqueLabels);
    Colormap      = hsv(NrLabels);
    mColors       = Colormap(CrispLabel(:),:);        
else
    if(size(L,2)==3) % we use this as the colormap
        mColors = bsxfun(@rdivide,L,sum(L,2));
    else             % define a reasonable color model
        NrLabels     = size(L,2);
        N            = size(L,1);       
        [MaxProbs,H] = max(L'); % crisp label
        Colormap     = hsv(NrLabels);        
        mColors      = Colormap(H',:);        
        for(k=1:N)
            [Prob,Ind]     = max(mColors(k,:));
            mColors(k,Ind) = Prob * MaxProbs(k);            
        end
    end
end
N = size(L,1);
figure;
hold;
if(nargin==2)
    for(k=1:N)
        plot(Data(k,1),Data(k,2),'o','MarkerFaceColor',mColors(k,:),'MarkerSize',10)
    end
else
    vLabels = varargin{1};
    vUnique  = unique(vLabels);
    [Y,vLabelsMapped] = ismember(vLabels,vUnique);
    sMarkers = {'s','o','d','p','h'};
    NrMarkers = numel(sMarkers)+1;
    for(k=1:N)
        plot(Data(k,1),Data(k,2),sMarkers{mod(vLabelsMapped(k),NrMarkers)},'MarkerFaceColor',mColors(k,:),'MarkerSize',10)
    end    
end