addpath(genpath('glvq_source'))
addpath(genpath('minFunc'))
load iris_test
[N,d]   = size(D);
mD      = bsxfun(@rdivide,bsxfun(@minus,D,mean(D)),std(D));
[L]     = argmax(irisTargets)';
Results = [];
iProtos = 3;
iMode   = 0;
iDimM   = d;
% GLVQ cross validated with 1 prototype per class and 5 times crossvalidation
[vModelResults,vClassifyResults] = crossvalidation_glvq(mD, L, 5,{iMode,iDimM,iProtos});

Results = [Results;[mean(vClassifyResults), std(vClassifyResults)]];

iMode   = 1;
iDimM   = d;
% GRLVQ (scaled euclidean distance) cross validated with 1 prototype per class and 5 times crossvalidation
[vModelResults,vClassifyResults] = crossvalidation_glvq(mD, L, 5,{iMode,iDimM,iProtos});

Results = [Results;[mean(vClassifyResults), std(vClassifyResults)]];

iMode   = 2;
iDimM   = d;
% GMLVQ (full parametric mahalanobis distance) cross validated with 1 prototype per class and 5 times crossvalidation
[vModelResults,vClassifyResults] = crossvalidation_glvq(mD, L, 5,{iMode,iDimM,iProtos});

Results = [Results;[mean(vClassifyResults), std(vClassifyResults)]];

iMode   = 2;
iDimM   = 2;
% LiRaM (parametric mahalanobis distance, rank reduced as d x M) cross validated with 1 prototype per class and 5 times crossvalidation
[vModelResults,vClassifyResults] = crossvalidation_glvq(mD, L, 5,{iMode,iDimM,iProtos});

Results = [Results;[mean(vClassifyResults), std(vClassifyResults)]];
% use Omega mapping of the fst model to obtain low dimensional visualization
xMapped = (vModelResults(1).Models.fDist.Omega * mD')';

Results
PlotData(xMapped,L)